/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the Api type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Api{}

// Api struct for Api
type Api struct {
	// Primary key of document. The value is null when document is not persisted.
	Id *string `json:"id,omitempty"`
	// Customer identifier
	CustomerId *string `json:"customer_id,omitempty"`
	// Dashboard app type
	App NullableString `json:"app,omitempty"`
	// Endpoint label
	Label *string `json:"label,omitempty"`
	// Last execution
	Last interface{} `json:"last,omitempty"`
}

// NewApi instantiates a new Api object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewApi() *Api {
	this := Api{}
	return &this
}

// NewApiWithDefaults instantiates a new Api object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewApiWithDefaults() *Api {
	this := Api{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *Api) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Api) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *Api) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *Api) SetId(v string) {
	o.Id = &v
}

// GetCustomerId returns the CustomerId field value if set, zero value otherwise.
func (o *Api) GetCustomerId() string {
	if o == nil || IsNil(o.CustomerId) {
		var ret string
		return ret
	}
	return *o.CustomerId
}

// GetCustomerIdOk returns a tuple with the CustomerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Api) GetCustomerIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerId) {
		return nil, false
	}
	return o.CustomerId, true
}

// HasCustomerId returns a boolean if a field has been set.
func (o *Api) HasCustomerId() bool {
	if o != nil && !IsNil(o.CustomerId) {
		return true
	}

	return false
}

// SetCustomerId gets a reference to the given string and assigns it to the CustomerId field.
func (o *Api) SetCustomerId(v string) {
	o.CustomerId = &v
}

// GetApp returns the App field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Api) GetApp() string {
	if o == nil || IsNil(o.App.Get()) {
		var ret string
		return ret
	}
	return *o.App.Get()
}

// GetAppOk returns a tuple with the App field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Api) GetAppOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.App.Get(), o.App.IsSet()
}

// HasApp returns a boolean if a field has been set.
func (o *Api) HasApp() bool {
	if o != nil && o.App.IsSet() {
		return true
	}

	return false
}

// SetApp gets a reference to the given NullableString and assigns it to the App field.
func (o *Api) SetApp(v string) {
	o.App.Set(&v)
}

// SetAppNil sets the value for App to be an explicit nil
func (o *Api) SetAppNil() {
	o.App.Set(nil)
}

// UnsetApp ensures that no value is present for App, not even an explicit nil
func (o *Api) UnsetApp() {
	o.App.Unset()
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *Api) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Api) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *Api) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *Api) SetLabel(v string) {
	o.Label = &v
}

// GetLast returns the Last field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Api) GetLast() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Last
}

// GetLastOk returns a tuple with the Last field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Api) GetLastOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Last) {
		return nil, false
	}
	return &o.Last, true
}

// HasLast returns a boolean if a field has been set.
func (o *Api) HasLast() bool {
	if o != nil && IsNil(o.Last) {
		return true
	}

	return false
}

// SetLast gets a reference to the given interface{} and assigns it to the Last field.
func (o *Api) SetLast(v interface{}) {
	o.Last = v
}

func (o Api) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Api) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.CustomerId) {
		toSerialize["customer_id"] = o.CustomerId
	}
	if o.App.IsSet() {
		toSerialize["app"] = o.App.Get()
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if o.Last != nil {
		toSerialize["last"] = o.Last
	}
	return toSerialize, nil
}

type NullableApi struct {
	value *Api
	isSet bool
}

func (v NullableApi) Get() *Api {
	return v.value
}

func (v *NullableApi) Set(val *Api) {
	v.value = val
	v.isSet = true
}

func (v NullableApi) IsSet() bool {
	return v.isSet
}

func (v *NullableApi) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableApi(val *Api) *NullableApi {
	return &NullableApi{value: val, isSet: true}
}

func (v NullableApi) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableApi) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
